Subject: Re: Linux seamless booting

From: Fortini Matteo <[email-masked]>
Date: Mon, 12 Oct 2009 15:54:59 +0200

Yes, that's what we're currently using, but the problem is a little 
broader: I should answer to CAN messages in at most 100-200ms from 
powerup, and that can be done in u-boot.
However, handing CAN transmission control over to Linux is quite 
complicated nowadays, since it would involve passing structures in 
memory and hacking through device init.
It'd be nice to have a framework with which u-boot could hand-over 
devices to Linux in a clean and defined way.
We were thinking about starting some kind of development in that 
direction, but with very little resources, so I was looking for someone 
who had looked at the same problem.

Thanks,
Matteo

Roberto Guerra ha scritto:
> Did you try "setenv bootdelay 0" in uboot?
>
> On Mon, Oct 12, 2009 at 7:07 AM, Fortini Matteo <[email-masked]> wrote:
>   
>> Hi all,
>> we've been working on a PPC512x board booting with u-boot + linux 2.6.24.6,
>> and one major issue for our application is boot time.
>>
>> Right now, we went down to less than 6s boot time (i.e. time from power off
>> to launch of the user app), even with some drivers installed, i.e.:
>>
>>   * CAN bus
>>   * GPU on PCI bus
>>   * USB host
>>   * UBI
>>
>> with r/o squashfs root and r/w ubifs configuration filesystem mounted from a
>> NOR flash memory.
>>
>> This time could be enough for the high-level application (we're showing a
>> splash screen in about 2-3s so it's ok if the main app takes a little longer
>> to come up), but the whole system is connected to others via CAN and we
>> can't afford the "black out" period between u-boot and linux.
>>
>> Some other operating systems (e.g. QNX) have this "seamless booting"
>> function, in which drivers are started in stages, so that a (minimal)
>> functionality can be given in milliseconds, and more functionalities come up
>> as time goes by.
>>
>> Is there a way to support something similar with the u-boot -> linux
>> solution?
>>
>> Thank you,
>> Matteo
>> _______________________________________________
>> Linuxppc-dev mailing list
>> [email-masked]
>> https://lists.ozlabs.org/listinfo/linuxppc-dev
>>
>>     
> .
>
>